import * as tslib_1 from "tslib";
import * as React from "react";
import { Breadcrumb } from "office-ui-fabric-react/lib/Breadcrumb";
import { Callout } from "office-ui-fabric-react/lib/Callout";
import { Link } from "office-ui-fabric-react/lib/Link";
import { BaseComponent, css } from "office-ui-fabric-react/lib/Utilities";
import { VssIcon } from "../../VssIcon";
import { PickList, PICKER_CHANGE_EVENT } from "../../PickList";
import * as VSSUIResources from '../../VSS.Resources.VSSUI';
import "./HubBreadcrumb.css";
export var HEADER_PICKER_CHANGE_EVENT = PICKER_CHANGE_EVENT;
/**
 *
 * @param item Properties for instantiating the hub dropdown.
 */
export function getDropdownIcon(item) { }
var PickerDropdown = /** @class */ (function (_super) {
    tslib_1.__extends(PickerDropdown, _super);
    function PickerDropdown(props) {
        var _this = _super.call(this, props) || this;
        _this.onPositioned = function () {
            _this._pickList.focus();
        };
        _this.onDismiss = function () {
            _this.closeDropdown();
        };
        _this.updateDelegate = function () { return _this.forceUpdate(); };
        _this.state = { calloutIsVisible: false };
        return _this;
    }
    PickerDropdown.prototype.render = function () {
        var _this = this;
        var _a = this.props, getPinElement = _a.getPinElement, item = _a.item, minWidth = _a.minWidth, pickListClassName = _a.pickListClassName;
        if (this.state.calloutIsVisible) {
            var picker_1 = item.headerItemPicker;
            return React.createElement(Callout, { isBeakVisible: false, target: getPinElement(), onPositioned: this.onPositioned, onDismiss: this.onDismiss },
                React.createElement(PickList, { className: css("picker-dropdown", pickListClassName), componentRef: function (pickList) { return (_this._pickList = pickList); }, getActions: function (items) { return picker_1.actions; }, getListItem: picker_1.getListItem, groups: picker_1.groups, indicators: picker_1.dropdownIndicators, initiallySelectedItems: picker_1.selectedItem ? [picker_1.selectedItem] : undefined, isSearchable: picker_1.isSearchable, items: picker_1.getItems(), searchResultsLoadingText: picker_1.searchResultsLoadingText, noItemsText: picker_1.noItemsText, searchNoResultsText: picker_1.searchNoResultsText, searchResultsGroupName: picker_1.searchResultsGroupName, searchTextPlaceholder: picker_1.searchTextPlaceholder, shouldVirtualize: function (items) {
                        return (items || []).length > 50;
                    }, width: minWidth, onFocusLost: this.onDismiss, onSearch: picker_1.onSearch, onSelectionChanged: item.onSelectionChanged }));
        }
        return null;
    };
    PickerDropdown.prototype.componentDidMount = function () {
        this._events.on(this.props.item.headerItemPicker, HEADER_PICKER_CHANGE_EVENT, this.updateDelegate);
    };
    PickerDropdown.prototype.componentWillUnmount = function () {
        this._events.off(this.props.item.headerItemPicker, HEADER_PICKER_CHANGE_EVENT, this.updateDelegate);
    };
    PickerDropdown.prototype.componentWillReceiveProps = function (nextProps) {
        if (this.props.item.headerItemPicker !== nextProps.item.headerItemPicker) {
            this._events.off(this.props.item.headerItemPicker, HEADER_PICKER_CHANGE_EVENT, this.updateDelegate);
            this._events.on(nextProps.item.headerItemPicker, HEADER_PICKER_CHANGE_EVENT, this.updateDelegate);
        }
    };
    PickerDropdown.prototype.openDropdown = function () {
        if (this.props.onPickListOpened) {
            this.props.onPickListOpened();
        }
        this.setState({ calloutIsVisible: true });
    };
    PickerDropdown.prototype.closeDropdown = function () {
        this.setState({ calloutIsVisible: false });
        if (this.props.onPickListClosed) {
            this.props.onPickListClosed();
        }
    };
    PickerDropdown.prototype.toggleDropdown = function () {
        if (this.state.calloutIsVisible) {
            this.closeDropdown();
        }
        else {
            this.openDropdown();
        }
    };
    return PickerDropdown;
}(BaseComponent));
export { PickerDropdown };
var HubBreadcrumb = /** @class */ (function (_super) {
    tslib_1.__extends(HubBreadcrumb, _super);
    function HubBreadcrumb(props) {
        var _this = _super.call(this, props) || this;
        _this.pinElements = {};
        _this.onRenderItem = function (item, defaultRenderer) {
            // We want the text AND the icon to be clickable, but since the defaultRenderer attaches the onClick
            // to the text only, we make sure that doesn't even render an on-click and that the onclick goes to
            // the element that contains both the text and icon.
            var itemNoOnClick = tslib_1.__assign({}, item);
            delete itemNoOnClick.onClick;
            delete itemNoOnClick.href;
            var icon = _this.getIcon(item.leftIconProps);
            var originalDefaultRendered = defaultRenderer(itemNoOnClick);
            var originalClassName = originalDefaultRendered.props && originalDefaultRendered.props.className;
            var clonedElementProps = tslib_1.__assign({}, originalDefaultRendered.props, { className: originalClassName
                    ? originalClassName + " vss-HubBreadcrumb--itemText"
                    : "vss-HubBreadcrumb--itemText", style: originalDefaultRendered.props.style ? tslib_1.__assign({}, originalDefaultRendered.props.style) : {} });
            if (_this.props.maxItemWidth) {
                clonedElementProps.style.maxWidth = _this.props.maxItemWidth;
            }
            var defaultRendered = React.cloneElement(originalDefaultRendered, clonedElementProps);
            var breadcrumbItem = null;
            var pickerDropdown = null;
            var iconVisible = item.headerItemPicker && !!item.onClick;
            var picker = item.headerItemPicker;
            if (picker) {
                var dropdownIcon = null;
                if (iconVisible) {
                    dropdownIcon = (React.createElement(VssIcon, { iconName: "ChevronDown", iconType: 0 /* fabric */, key: "RightIcon$" + item.key, className: css("vss-HubBreadcrumb--item-dropdown") }));
                }
                return (React.createElement("div", { ref: function (elem) {
                        if (elem) {
                            _this.pinElements[item.key] = elem;
                        }
                    }, className: css({ "vss-HubBreadcrumb--item": true, "no-click": !item.onClick }) },
                    React.createElement(Link, { key: "BreadcrumbItem$" + item.key, onClick: item.onClick, href: item.href, "aria-haspopup": true, "aria-expanded": _this.state.pickerIsOpen, "aria-label": item.ariaLabel },
                        React.createElement("div", { className: 'vss-HubBreadcrumb--itemContainer' },
                            icon,
                            defaultRendered,
                            dropdownIcon))));
            }
            else if (item.onClick || item.href) {
                return (React.createElement("div", { className: css("vss-HubBreadcrumb--item") },
                    React.createElement(Link, { key: "BreadcrumbItem$" + item.key, onClick: item.onClick, href: item.href, "aria-label": item.ariaLabel },
                        React.createElement("div", { className: 'vss-HubBreadcrumb--itemContainer' },
                            icon,
                            defaultRendered))));
            }
            else {
                return (React.createElement("div", { className: css("vss-HubBreadcrumb--item"), "aria-label": item.ariaLabel },
                    icon,
                    defaultRendered));
            }
        };
        _this.state = {
            pickerIsOpen: false
        };
        return _this;
    }
    HubBreadcrumb.prototype.getIcon = function (iconProps) {
        if (iconProps) {
            return React.createElement(VssIcon, tslib_1.__assign({ className: "vss-HubBreadcrumb--item-leftIcon" }, iconProps));
        }
        return null;
    };
    HubBreadcrumb.prototype.render = function () {
        var _this = this;
        var itemWithPicker;
        var _a = this.props, items = _a.items, pickListClassName = _a.pickListClassName, pickListMinWidth = _a.pickListMinWidth, ariaLabel = _a.ariaLabel;
        //We only get the last item in the list of items that contains a headerItemPicker.
        for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
            var item = items_1[_i];
            if (item.headerItemPicker) {
                itemWithPicker = item;
            }
        }
        return (React.createElement("div", { className: "vss-HubBreadcrumb--container" },
            React.createElement(Breadcrumb, { onReduceData: function (data) { return undefined; }, maxDisplayedItems: 4, items: items, className: css("vss-HubBreadcrumb"), onRenderItem: this.onRenderItem, ariaLabel: ariaLabel || VSSUIResources.BreadcrumbAriaLabel }),
            itemWithPicker &&
                React.createElement(PickerDropdown, { ref: function (pickList) { _this.pickList = pickList; }, item: itemWithPicker, getPinElement: function () { return _this.pinElements[itemWithPicker.key]; }, minWidth: pickListMinWidth ? pickListMinWidth : this.pinElements[itemWithPicker.key] && this.pinElements[itemWithPicker.key].clientWidth, pickListClassName: pickListClassName, onPickListClosed: function () { return _this.setState({ pickerIsOpen: false }); }, onPickListOpened: function () { return _this.setState({ pickerIsOpen: true }); } })));
    };
    return HubBreadcrumb;
}(BaseComponent));
export { HubBreadcrumb };
