import * as tslib_1 from "tslib";
import * as React from "react";
import { IconButton } from "office-ui-fabric-react/lib/Button";
import { BaseComponent, css } from "office-ui-fabric-react/lib/Utilities";
import { VssIcon } from "../../VssIcon";
import "./IconToggleButton.css";
/**
 * Allows user to set 2 different icons for a button and switch between them on clicks
 */
var IconToggleButton = /** @class */ (function (_super) {
    tslib_1.__extends(IconToggleButton, _super);
    function IconToggleButton() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._onClick = function (ev) {
            ev.preventDefault();
            if (_this.props.onToggle) {
                _this.props.onToggle(!_this.props.isToggledOn);
            }
        };
        return _this;
    }
    IconToggleButton.prototype.render = function () {
        var _a = this.props, className = _a.className, isToggledOn = _a.isToggledOn, onToggle = _a.onToggle, toggledOffIconProps = _a.toggledOffIconProps, toggledOnIconProps = _a.toggledOnIconProps;
        var iconClassName = css("vss-IconToggleButton", "icon-toggle-button", className, { "is-toggled-on": isToggledOn });
        return (React.createElement(IconButton, { className: iconClassName, onClick: this._onClick, iconProps: VssIcon.getIconProps(isToggledOn ? toggledOnIconProps : toggledOffIconProps) }));
    };
    return IconToggleButton;
}(BaseComponent));
export { IconToggleButton };
