import * as tslib_1 from "tslib";
import * as React from "react";
import { TreeList } from "../../Components/Tree/TreeList";
import { BaseComponent } from "office-ui-fabric-react/lib/Utilities";
import "./Tree.css";
var Tree = /** @class */ (function (_super) {
    tslib_1.__extends(Tree, _super);
    function Tree(props) {
        var _this = _super.call(this, props) || this;
        _this.onItemToggled = function (treeListItem) {
            var collapsedIds = tslib_1.__assign({}, _this.state.collapsedIds);
            var expandedIds = tslib_1.__assign({}, _this.state.expandedIds);
            collapsedIds[treeListItem.treeItem.id] = treeListItem.isExpanded;
            expandedIds[treeListItem.treeItem.id] = !treeListItem.isExpanded;
            _this.setState({
                collapsedIds: collapsedIds,
                expandedIds: expandedIds
            });
        };
        _this.state = {
            collapsedIds: {},
            expandedIds: {}
        };
        return _this;
    }
    Tree.prototype.render = function () {
        var _a = this.props, treeItems = _a.treeItems, primaryTreeColumnKey = _a.primaryTreeColumnKey, actionsColumnKey = _a.actionsColumnKey, getMenuItemProviders = _a.getMenuItemProviders, getMenuItems = _a.getMenuItems, allocateSpaceForActionsButtonWhileHidden = _a.allocateSpaceForActionsButtonWhileHidden;
        var columns = this.props.columns.slice();
        var treeListItemColumns = columns.map(function (column) {
            return tslib_1.__assign({}, column, { onRender: function (treeListItem) { return column.onRender(treeListItem.treeItem); } });
        });
        var treeListItems = [];
        for (var _i = 0, treeItems_1 = treeItems; _i < treeItems_1.length; _i++) {
            var treeItem = treeItems_1[_i];
            this.addTreeListItemsForTreeItem(treeItem, treeListItems, 0);
        }
        return React.createElement(TreeList, { treeListItems: treeListItems, columns: treeListItemColumns, onItemToggled: this.onItemToggled, primaryTreeColumnKey: primaryTreeColumnKey, actionsColumnKey: actionsColumnKey, getMenuItems: getMenuItems, getMenuItemProviders: getMenuItemProviders, allocateSpaceForActionsButtonWhileHidden: allocateSpaceForActionsButtonWhileHidden });
    };
    Tree.prototype.addTreeListItemsForTreeItem = function (treeItem, treeListItems, indentLevel) {
        var nodeExpandedState = treeItem.defaultIsExpanded;
        if (this.state.collapsedIds[treeItem.id]) {
            nodeExpandedState = false;
        }
        else if (this.state.expandedIds[treeItem.id]) {
            nodeExpandedState = true;
        }
        var treeListItem = {
            treeItem: treeItem,
            indentLevel: indentLevel,
            isExpandable: treeItem.children !== undefined,
            isExpanded: nodeExpandedState
        };
        treeListItems.push(treeListItem);
        if (treeItem.children && treeItem.children.length > 0 && nodeExpandedState) {
            for (var _i = 0, _a = treeItem.children; _i < _a.length; _i++) {
                var child = _a[_i];
                this.addTreeListItemsForTreeItem(child, treeListItems, indentLevel + 1);
            }
        }
    };
    return Tree;
}(BaseComponent));
export { Tree };
